<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
        <meta name="description" content="" />
        <meta name="author" content="" />
        <title>Easy2Track Besucher Statistics</title>
        <!-- Favicon-->
        <link rel="icon" href="./favicon-1.ico" sizes="32x32"/>
        <link rel="icon" href="./favicon-1.ico" sizes="192x192"/>
        <link rel="apple-touch-icon" href="./favicon-1.ico"/>
        <meta name="msapplication-TileImage" content="./favicon-1.ico"/>

        <!-- Bootstrap Icons-->
        <link href="./css/bootstrap-icons.css?v=[cs_version]" rel="stylesheet" />
        <!-- fonts-->
        <link href="./css/font.css?v=[cs_version]" rel="stylesheet" />

       
        <!-- App function CSS -->
        <link href="./pbcdn/vendor/semanticui/semantic.min.css?v=[cs_version]" rel="stylesheet">
        <link rel="stylesheet" media="all" href="./pbcdn/css/jquery.dynatable.css?v=[cs_version]"/>


        <!-- Core theme CSS (includes Bootstrap)-->
        <link href="css/easy2track-custom.css?v=[cs_version]" rel="stylesheet" />
        <link rel="stylesheet" href="/style-global/css/serviceblick-global.css?v=[cs_version]">
        <link href="css/style.css?v=[cs_version]" rel="stylesheet" />

    
        <meta name="viewport" content="width=device-width, initial-scale=1.0, viewport-fit=cover"/>
    </head>
    <body class="d-flex flex-column h-100">

        <!-- <div id="spinner">
            <div class="loader">
                <div class="face">
                    <div class="circle"></div>
                </div>
                <div class="face">
                    <div class="circle"></div>
                </div>
                <div id="spinner_message">
                    System wird geladen...
                </div>
            </div>
        </div> -->
        {% include 'snippets/pb-loader.tpl' %} 
        <div id="contentwrapper" style="display:none;" class="d-flex flex-column h-100">
        <!-- Navigation-->
        <nav class="navbar navbar-expand-lg navbar-light fixed-top py-3" id="mainNav">
            <div class="container px-4 px-lg-5">
                <a class="navbar-brand" href="#page-top">Easy2Track</a>
                <button class="navbar-toggler navbar-toggler-right" type="button" data-bs-toggle="collapse"
                    data-bs-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false"
                    aria-label="Toggle navigation"><span class="navbar-toggler-icon"></span></button>
                <div class="collapse navbar-collapse" id="navbarResponsive">
                    <ul class="navbar-nav ms-auto my-2 my-lg-0">
                        <li class="nav-item"><a class="nav-link" href="../dashboard/"><i class="bi bi-speedometer2" aria-label="Dashboard"></i> Dashboard</a></li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle  active" href="#" id="navbarScrollingDropdown" role="button"
                                data-bs-toggle="dropdown" aria-expanded="false">
                                Für Betreiber:innen</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarScrollingDropdown">
                                <li><a class="dropdown-item" href="client.html">Classic QR-Code</a></li>
                                <li><a class="dropdown-item" href="scanner.html">Checkin Scanner</a></li>
                                <li><a class="dropdown-item active" href="visitors.html">Admin Panel</a></li>
                            </ul>
                        </li>
                    </ul>
                    <a class="btn btn-primary btn-md ms-4" href="#" id="logout_button"><i class="bi bi-box-arrow-right fs-5" aria-label="Abmelden"></i> Abmelden</a>
                </div>
            </div>
        </nav>

        
        <section class="page-section pb-5 flex-shrink-0" >
            <div class="container px-4 px-lg-5">
                <div class="row gx-4 gx-lg-5 justify-content-center">
                    <div class="col-lg-10 text-center">
                        <h2 class="mt-0">Admin Panel</h2>
                        <hr class="divider" />
                    </div>
                </div>

                <!-- Statistics-->
                <div class="row gx-4 gx-lg-5 justify-content-center">
                    
                    <div class="col-lg-12" data-content="content_1">
                        <div class="row">
                            <div class="col-md-3 pb-5">
                                <h5>Besucher-Anzahl</h5>
                                <p class="current_visitors">
                                    <div class="current_visitors d-inline">aktuell: </div><div class="current_visitors d-inline fw-bold" id="current_visitors">0</div>
                                </p>
                                <p class="todays_visitors">
                                    <div class="todays_visitors d-inline">heute: </div><div class="todays_visitors d-inline fw-bold" id="sum_visitors">0</div>
                                </p>
                                <p class="average_duration">
                                    <div class="average_duration d-inline">Ø Aufenthalt (min): </div><div class="average_duration d-inline fw-bold" id="average_duration">0</div>
                                </p>
                            </div>
                            <div class="col-md-9 pb-5">
                                <h5>Besucher-Liste</h5>
                                <p><span class="setting_name">Auto-Checkout nach: </span><input class="form-control-sm" id="auto_logout_minutes" onchange="fetchData();" value="180"/><span> min</span></p>
                                
                                    <div class="container px-0 pt-3">
                                        <table id="example" class="table table-striped" cellspacing="0" width="100%">
                                            <thead>
                                            <th data-dynatable-column="id">Besucher ID</th>
                                            <th data-dynatable-column="checkedin_formatted">Check IN</th>
                                            <th data-dynatable-column="checkedout_formatted">Check OUT</th>
                                            <th data-dynatable-column="duration">Aufenthalt in Min</th>
                                            </thead>
                                            <tbody>
                                            </tbody>
                                        </table>
                                    </div>

                            </div>
                        </div>
                        <div class="row">
                            <div class="col">
                                <h5>Zustrom / Abfluss</h5>
                                <canvas id="canvas_diagramm" style="width:100%; border:1px solid #E65858;border-radius:4px;"></canvas>
                            </div>
                        </div>
                    </div>

                </div>
        </section>
 
       
        <!-- Footer-->
        <footer class="footer mt-auto bg-light py-4">
            <div class="container px-4 px-lg-5">
                <div class="small text-center text-muted">&copy; <script>document.write(new Date().getFullYear())</script> serviceBLICK by planBLICK GmbH 
                </br></br>
                <a href="https://impressum.planblick.com" target="planblick" >Impressum</a>
                <span class="text-muted mx-2">|</span>
                <a href="https://datenschutz.planblick.com" target="planblick">Datenschutz</a></div>
            </div>
        </footer>
    </div><!--contentwrapper-->
<!-- Bootstrap core JS-->
<script src="./js/bootstrap.bundle.min.js?v=[cs_version]"></script>

<!-- Core theme JS-->
<script src="./js/theme-scripts.js?v=[cs_version]"></script>

<!-- from old layout-->
<!-- Include jquery and init.js. All other includes will be handled in init.js -->
<script src="./pbcdn/vendor/jquery/jquery.min.js?v=[cs_version]"></script>
<script src="./pbcdn/vendor/moment-with-locales.min.js?v=[cs_version]"></script>

<script type="module">import {Init} from './js/init.js?v=[cs_version]'; new Init().load();</script>
<script type="module">import {pb_events} from './js/events.js?v=[cs_version]'; window.pb_events = new pb_events();</script>
<script type="module">import {CONFIG} from './pbcdn/config.js?v=[cs_version]'; window.CONFIG = CONFIG;</script>
<script type='text/javascript' src='./pbcdn/vendor/jquery.dynatable.js?v=[cs_version]'></script>
<script type="module">import {Account} from './pbcdn/account-api.js?v=[cs_version]'; window.Account = Account;</script>
<script defer type="module">
    import {pbBrain} from '../csf-lib/pb-brain.js?v=[cs_version]';
    new pbBrain().boot("easy2track-visitors-circuit");
</script>
<script type="text/javascript">
 var isFirefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;


document.addEventListener("SIOConnected", function (event) {
    setInterval(fetchData, 3000)
})

var table_initialized = false
function fetchData() {
    apikey = $.cookie("apikey");

    result = false

    url = CONFIG.API_BASE_URL + "/easy2track/current_visitors";
    $.ajax({
        type: "GET",
        url: url,
        data: "",
        beforeSend: function (xhr){
            xhr.setRequestHeader('apikey', apikey);
        },
        success: function (response) {
            data = formatData(response)
            if(!table_initialized) {
                table_initialized = true
                $.dynatableSetup({
                    // your global default options here
                    dataset: {
                        perPageDefault: 10,
                        perPageOptions: [10, 20, 50, 100],
                        sorts: {'status': -1},
                    }
                });

                $('#example').dynatable({
                    dataset: {
                        records: (data)
                    }
                });
                if ($("#loader-overlay")) {
                    $("#loader-overlay").hide()
                    $("#contentwrapper").show()
                }
            } else {
                console.log($('#example').data('dynatable'))
                var dynatable = $('#example').data('dynatable');
                dynatable.settings.dataset.originalRecords = data;
                dynatable.process();
            }
        },
       // error: function(){
        //    alert("Hey Da ist etwas schief gelaufen. Versuche es bitte noch einmal.")
       // }
      }).done(function(o) {

      });
}

function formatData(data) {
    let statistic = {checkins: {7: 0, 8: 0, 9: 0, 10: 0, 11: 0, 12 : 0, 13 : 0, 14 : 0, 15 : 0, 16 : 0, 17 : 0, 18 : 0, 19 : 0, 20 : 0, 21 : 0, 22 : 0, 23: 0},
                    checkouts: {7: 0, 8: 0, 9: 0, 10: 0, 11: 0, 12 : 0, 13 : 0, 14 : 0, 15 : 0, 16 : 0, 17 : 0, 18 : 0, 19 : 0, 20 : 0, 21 : 0, 22 : 0, 23: 0}}
    let current_visitors = 0
    let sum_visitors = 0
    let sum_duration = 0

    for(row_index in data) {

        if (data[row_index]["duration"]) {
            //data[row_index]["duration"] = data[row_index]["duration"].toFixed(2)
        } else {
            data[row_index]["duration"] = "-"
        }
        datetimeFormat = "DD.MM.YYYY HH:mm";
        mysqldatetimeFormat = "YYYY-MM-DD HH:mm:ss";

        data[row_index]["checkedin"] = moment.utc(data[row_index]["checkedin"], mysqldatetimeFormat)
        data[row_index]["checkedin_formatted"]= data[row_index]["checkedin"].format(datetimeFormat)
        if(data[row_index]["checkedout"]) {
            data[row_index]["checkedout"] = moment.utc(data[row_index]["checkedout"], mysqldatetimeFormat)
            data[row_index]["checkedout_formatted"] = data[row_index]["checkedout"].format(datetimeFormat)
        } else {
            // After how many minutes a person shall be treated as checked out even if no active checkout exists
            var minutes = $("#auto_logout_minutes").val()
            var check_out_date_faked = data[row_index]["checkedin"].add(minutes, 'minutes')

            if(moment().isAfter(check_out_date_faked.local("Europe/Berlin"))) {
                data[row_index]["checkedout"] = check_out_date_faked
                data[row_index]["checkedout_formatted"] = "<i>" + check_out_date_faked.format(datetimeFormat) + " <span class='auto_checkout_label'>(Auto-Checkout)</span></i>"
                data[row_index]["duration"] = minutes
            } else {
                data[row_index]["checkedout_formatted"] = "-"
            }

        }

        if(parseInt(data[row_index]["duration"]) > 0) {
            sum_duration += parseInt(data[row_index]["duration"])
        }

        let checkin_hour = parseInt(data[row_index]["checkedin"].format("HH"))
        current_visitors++
        sum_visitors++
        if(!statistic.checkins[checkin_hour]) {
            statistic.checkins[checkin_hour] = 1
        } else {
            statistic.checkins[checkin_hour]++;
        }

        if(data[row_index]["checkedout"]) {
            let checkout_hour = parseInt(data[row_index]["checkedout"].format("HH"))
            current_visitors--
            if (!statistic.checkouts[checkout_hour]) {
                statistic.checkouts[checkout_hour] = 1
            } else {
                statistic.checkouts[checkout_hour]++;
            }
        }
    }
    setAverageDuration(sum_duration/sum_visitors)
    setVisitorCounters(current_visitors, sum_visitors)
    renderStatistic(statistic)
    return data
}

function setAverageDuration(duration)
{
    $("#average_duration").html(parseInt(duration))
}

function setVisitorCounters(current_visitors, sum_visitors) {
    $("#current_visitors").html(current_visitors)
    $("#sum_visitors").html(sum_visitors)
}

function renderStatistic(statistic) {
    var canvas = document.getElementById("canvas_diagramm");
    var canvasWidth = 1400;
    var canvasHeight = 350;
    canvas.setAttribute('width', canvasWidth);
    canvas.setAttribute('height', canvasHeight);
    var cv = canvas.getContext("2d");
//Options Grid
    var graphGridSize = 20;
    var graphGridX = (canvasWidth / graphGridSize).toFixed();
//Draw Grid
    for (var i = 0; i < graphGridX; i++) {
        cv.moveTo(canvasWidth, graphGridSize * i);
        cv.lineTo(0, graphGridSize * i);
    }
    cv.strokeStyle = "#dbdbdb";
    cv.stroke();


//Data Graph
    let values = []
    for(i in statistic.checkins) {
        if(typeof statistic.checkins[i] != "undefined") {
            values.push({A: i + "-" + (parseInt(i) + 1) + " Uhr: " + statistic.checkins[i], B: statistic.checkins[i] + 1, C: "#34791f"})
        }
        if(typeof statistic.checkouts[i] != "undefined") {
            values.push({A: "/" + statistic.checkouts[i], B: statistic.checkouts[i] + 1, C: "#e65858"})
        }
    }
    var data = {
        values: values
    };

//Options Graph
    var graphMax = 160;
    var graphPadding = 10;
    var graphFaktor = (canvasHeight - (2 * graphPadding)) / graphMax;
    var graphWidth = (canvasWidth - graphPadding) / data.values.length;
    var graphTextcolor = '#000000';

//Draw Graph
    for (var i = 0; i < data.values.length; i++) {
        let tmpTop = (canvasHeight - (graphFaktor * data.values[i].B)).toFixed() - graphPadding;
        let tmpHeight = ((data.values[i].B * graphFaktor)).toFixed();
        cv.fillStyle = data.values[i].C;
        cv.fillRect(graphWidth + ((i - 1) * graphWidth) + graphPadding, tmpTop, graphWidth - graphPadding, tmpHeight);
        cv.fillStyle = graphTextcolor;
        cv.fillText(data.values[i].A, graphWidth + ((i - 1) * graphWidth) + graphPadding + 2, canvasHeight - 2, graphWidth);
    }
}
</script>

<div id="login_modal" class="modal" aria-modal="true" role="dialog">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h6 class="modal-title">Login benötigt</h6>

            </div>
            <div class="modal-body">
                <div id="login_container" class="m-4">
                    <div class="pb-3">
                        <input id="login" type="text" placeholder="Benutzername" class="form-control">
                    </div>
                    <div>
                        <input id="password" type="password" placeholder="Password" class="form-control">
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-primary"
                    onclick="new Account().getapikey(function() {location.reload();});">Anmelden</button>
            </div>
        </div>
    </div><!-- modal-dialog -->
</div>

</body>
</html>
